//+-------------------------------------------------------------------------------------+
//|                                                                      AutoLevels.mq4 |
//|                                                                           Scriptong |
//|                                                                   scriptong@mail.ru |
//+-------------------------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

#property indicator_chart_window
//---- input parameters
extern int       StartPoints=30;
extern int       StepPoints=50;
extern color     LevelColor = MediumSeaGreen;

int StartLevel, FinishLevel, NewStart, NewFinish;
//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
  {
// - 1 - ====================      ====================   
   StartLevel = MathFloor(Low[iLowest(Symbol(), 0, MODE_LOW, Bars)]/Point/100)*
                100 + StartPoints;
   FinishLevel = High[iHighest(Symbol(), 0, MODE_HIGH, Bars)]/Point;
// - 1 - ====================   ===========================================   

// - 2 - ===========================   ================================
   ShowAllLevels();
// - 2 - ==========================   =====================================   
   return(0);
  }

//+-------------------------------------------------------------------------------------+
//|                                                              |
//+-------------------------------------------------------------------------------------+
void ShowLevel(int Level)
{
 string Name = "AL_"+DoubleToStr(Level, 0);
 if (ObjectFind(Name) < 0)
   {
    ObjectCreate(Name, OBJ_HLINE, 0, 1, Level*Point);
    ObjectSet(Name, OBJPROP_COLOR, LevelColor);
    ObjectSet(Name, OBJPROP_BACK, True);
   }
}

//+-------------------------------------------------------------------------------------+
//|                                                               |
//+-------------------------------------------------------------------------------------+
void ShowAllLevels()
{
  int i = StartLevel;
  while (i <= FinishLevel)
    {
     ShowLevel(i);
     i += StepPoints;
    }
}
  
//+-------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                          |
//+-------------------------------------------------------------------------------------+
int deinit()
{
// - 1 - ===========================   ===================================
  int i = StartLevel;
  while (i <= FinishLevel)
    {
     if (ObjectFind("AL_"+DoubleToStr(i, 0)) == 0)
       ObjectDelete("AL_"+DoubleToStr(i, 0));
     i += StepPoints;
    }
// - 1 - ==========================   =====================================   
  return(0);
}
  
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
{
// - 1 - ====================    =====================================   
   NewStart = MathFloor(Low[iLowest(Symbol(), 0, MODE_LOW, Bars)]/Point/100)*
                100 + StartPoints;
   NewFinish = High[iHighest(Symbol(), 0, MODE_HIGH, Bars)]/Point;
// - 1 - ====================   ===========================================   

// - 2 - ====================    ==================================
   if (NewStart < StartLevel || NewFinish > FinishLevel)
     {
      StartLevel = NewStart;
      FinishLevel = NewFinish;
      ShowAllLevels();
     }
// - 2 - ==========================   =====================================   

   return(0);
}

